//
//  LBRGreekCharset.m
//  RocciConverter
//
//  Created by Claudio Capobianco on 30/01/13.
//  Copyright (c) 2013 Librum. All rights reserved.
//

#import "LBRGreekCharset.h"
#import "unicodeFontset.h"

@implementation LBRGreekCharset

NSCharacterSet* createSet(unichar chars[], size_t len)
{
    
    NSString *string = [[NSString alloc] initWithCharacters:chars
                                                     length:len / sizeof(UniChar)];
    NSCharacterSet *chset = [NSCharacterSet
                             characterSetWithCharactersInString:string];
    
    
    
    return chset;
    
}

+(NSCharacterSet*)createAlphaVariantCharSet {
    //NSLog(@"Creating alpha set...");
    UniChar alphaChars[] = {
        //UNICODE_ALPHA,
        UNICODE_ALPHA_OXIA2,
        UNICODE_ALPHA_PSILI,
        UNICODE_ALPHA_DASIA,
        UNICODE_ALPHA_PSILI_VARIA,
        UNICODE_ALPHA_DASIA_VARIA,
        UNICODE_ALPHA_PSILI_OXIA,
        UNICODE_ALPHA_DASIA_OXIA,
        UNICODE_ALPHA_PSILI_PERISPOMENI,
        UNICODE_ALPHA_DASIA_PERISPOMENI,
        UNICODE_ALPHA_VARIA,
        UNICODE_ALPHA_OXIA,
        UNICODE_ALPHA_PSILI_YPOGERGRAMMENI,
        UNICODE_ALPHA_DASIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_PSILI_VARIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_DASIA_VARIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_PSILI_OXIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_DASIA_OXIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_PSILI_PERISPOMENI_YPOGERGRAMMENI,
        UNICODE_ALPHA_DASIA_PERISPOMENI_YPOGERGRAMMENI,
        UNICODE_ALPHA_VRACHY,
        UNICODE_ALPHA_VRACHY_OXIA,
        UNICODE_ALPHA_MACRON,
        UNICODE_ALPHA_MACRON_OXIA,
        UNICODE_ALPHA_MACRON_PSILI,
        UNICODE_ALPHA_MACRON_DASIA,
        UNICODE_ALPHA_VARIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_YPOGERGRAMMENI,
        UNICODE_ALPHA_OXIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_PERISPOMENI,
        UNICODE_ALPHA_PERISPOMENI_YPOGERGRAMMENI,
//        UNICODE_CAPITAL_ALPHA,
//        UNICODE_CAPITAL_ALPHA_PSILI,
//        UNICODE_CAPITAL_ALPHA_DASIA,
//        UNICODE_CAPITAL_ALPHA_PSILI_VARIA,
//        UNICODE_CAPITAL_ALPHA_DASIA_VARIA,
//        UNICODE_CAPITAL_ALPHA_PSILI_OXIA,
//        UNICODE_CAPITAL_ALPHA_DASIA_OXIA,
//        UNICODE_CAPITAL_ALPHA_PSILI_PERISPOMENI,
//        UNICODE_CAPITAL_ALPHA_DASIA_PERISPOMENI,
//        UNICODE_CAPITAL_ALPHA_VARIA,
//        UNICODE_CAPITAL_ALPHA_OXIA,
//        UNICODE_CAPITAL_ALPHA_VRACHY,
//        UNICODE_CAPITAL_ALPHA_MACRON,
//        UNICODE_CAPITAL_ALPHA_PERISPOMENI,
    };
    return createSet(alphaChars,sizeof(alphaChars));
}

+(NSCharacterSet*)createEpsilonVariantCharSet {
    //NSLog(@"Creating epsilon set...");
    UniChar epsilonChars[] = {
        //UNICODE_EPSILON,
        UNICODE_EPSILON_OXIA2,
        UNICODE_EPSILON_PSILI,
        UNICODE_EPSILON_DASIA,
        UNICODE_EPSILON_PSILI_VARIA,
        UNICODE_EPSILON_DASIA_VARIA,
        UNICODE_EPSILON_PSILI_OXIA,
        UNICODE_EPSILON_DASIA_OXIA,
        UNICODE_EPSILON_VARIA,
        UNICODE_EPSILON_OXIA
    };
    
    return createSet(epsilonChars,sizeof(epsilonChars));
}

+(NSCharacterSet*)createEtaVariantCharSet {
    //NSLog(@"Creating eta set...");
    UniChar etaChars[] = {
        //ETA,
        UNICODE_ETA_OXIA2,
        UNICODE_ETA_PSILI,
        UNICODE_ETA_DASIA,
        UNICODE_ETA_PSILI_VARIA,
        UNICODE_ETA_DASIA_VARIA,
        UNICODE_ETA_PSILI_OXIA,
        UNICODE_ETA_DASIA_OXIA,
        UNICODE_ETA_PSILI_PERISPOMENI,
        UNICODE_ETA_DASIA_PERISPOMENI,
        UNICODE_ETA_VARIA,
        UNICODE_ETA_OXIA,
        UNICODE_ETA_PSILI_YPOGERGRAMMENI,
        UNICODE_ETA_DASIA_YPOGERGRAMMENI,
        UNICODE_ETA_PSILI_VARIA_YPOGERGRAMMENI,
        UNICODE_ETA_DASIA_VARIA_YPOGERGRAMMENI,
        UNICODE_ETA_PSILI_OXIA_YPOGERGRAMMENI,
        UNICODE_ETA_DASIA_OXIA_YPOGERGRAMMENI,
        UNICODE_ETA_PSILI_PERISPOMENI_YPOGERGRAMMENI,
        UNICODE_ETA_DASIA_PERISPOMENI_YPOGERGRAMMENI,
        UNICODE_ETA_VARIA_YPOGERGRAMMENI,
        UNICODE_ETA_YPOGERGRAMMENI,
        UNICODE_ETA_OXIA_YPOGERGRAMMENI,
        UNICODE_ETA_PERISPOMENI,
        UNICODE_ETA_PERISPOMENI_YPOGERGRAMMENI
    };
    return createSet(etaChars,sizeof(etaChars));
}

+(NSCharacterSet*)createIotaVariantCharSet {
    //NSLog(@"Creating iota set...");
    UniChar iotaChars[] = {
        //UNICODE_IOTA,
        UNICODE_IOTA,
        UNICODE_IOTA_OXIA2,
        UNICODE_IOTA_PSILI,
        UNICODE_IOTA_DASIA,
        UNICODE_IOTA_PSILI_VARIA,
        UNICODE_IOTA_DASIA_VARIA,
        UNICODE_IOTA_PSILI_OXIA,
        UNICODE_IOTA_DASIA_OXIA,
        UNICODE_IOTA_PSILI_PERISPOMENI,
        UNICODE_IOTA_DASIA_PERISPOMENI,
        UNICODE_IOTA_VARIA,
        UNICODE_IOTA_OXIA,
        UNICODE_IOTA_VRACHY,
        UNICODE_IOTA_VRACHY_OXIA,
        UNICODE_IOTA_MACRON,
        UNICODE_IOTA_MACRON_OXIA,
        UNICODE_IOTA_VARIA_DIALYTIKA,
        UNICODE_IOTA_DIALYTIKA,
        UNICODE_IOTA_DIALYTIKA_VARIA,
        UNICODE_IOTA_DIALYTIKA_OXIA,
        UNICODE_IOTA_PERISPOMENI,
        UNICODE_IOTA_PERISPOMENI_DIALYTIKA
    };
    return createSet(iotaChars,sizeof(iotaChars));
    
}

+(NSCharacterSet*)createOmicronVariantCharSet {
    //NSLog(@"Creating omicron set...");
    UniChar omicronChars[] = {
        //UNICODE_OMICRON,
        UNICODE_OMICRON_PSILI,
        UNICODE_OMICRON_DASIA,
        UNICODE_OMICRON_PSILI_VARIA,
        UNICODE_OMICRON_DASIA_VARIA,
        UNICODE_OMICRON_PSILI_OXIA,
        UNICODE_OMICRON_DASIA_OXIA,
        UNICODE_OMICRON_VARIA,
        UNICODE_OMICRON_OXIA
    };
    return createSet(omicronChars,sizeof(omicronChars));
}

+(NSCharacterSet*)createUpsilonVariantCharSet {
    //NSLog(@"Creating upsilon set...");
    UniChar upsilonChars[] = {
        //UNICODE_UPSILON,
        UNICODE_UPSILON_OXIA2,
        UNICODE_UPSILON_PSILI,
        UNICODE_UPSILON_DASIA,
        UNICODE_UPSILON_PSILI_VARIA,
        UNICODE_UPSILON_DASIA_VARIA,
        UNICODE_UPSILON_PSILI_OXIA,
        UNICODE_UPSILON_DASIA_OXIA,
        UNICODE_UPSILON_PSILI_PERISPOMENI,
        UNICODE_UPSILON_DASIA_PERISPOMENI,
        UNICODE_UPSILON_VARIA,
        UNICODE_UPSILON_OXIA,
        UNICODE_UPSILON_VRACHY,
        UNICODE_UPSILON_VRACHY_OXIA,
        UNICODE_UPSILON_MACRON,
        UNICODE_UPSILON_MACRON_OXIA,
        UNICODE_UPSILON_VARIA_DIALYTIKA,
        UNICODE_UPSILON_OXIA_DIALYTIKA,
        UNICODE_UPSILON_DIALYTIKA,
        UNICODE_UPSILON_PERISPOMENI,
        UNICODE_UPSILON_PERISPOMENI_DIALYTIKA
    };
    return createSet(upsilonChars,sizeof(upsilonChars));
}


+(NSCharacterSet*)createOmegaVariantCharSet {
    //NSLog(@"Creating omega set...");
    UniChar omegaChars[] = {
        //UNICODE_OMEGA,
        UNICODE_OMEGA_PSILI,
        UNICODE_OMEGA_DASIA,
        UNICODE_OMEGA_PSILI_VARIA,
        UNICODE_OMEGA_DASIA_VARIA,
        UNICODE_OMEGA_PSILI_OXIA,
        UNICODE_OMEGA_DASIA_OXIA,
        UNICODE_OMEGA_PSILI_PERISPOMENI,
        UNICODE_OMEGA_DASIA_PERISPOMENI,
        UNICODE_OMEGA_VARIA,
        UNICODE_OMEGA_OXIA,
        UNICODE_OMEGA_PSILI_YPOGERGRAMMENI,
        UNICODE_OMEGA_DASIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_PSILI_VARIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_DASIA_VARIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_PSILI_OXIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_DASIA_OXIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_PSILI_PERISPOMENI_YPOGERGRAMMENI,
        UNICODE_OMEGA_DASIA_PERISPOMENI_YPOGERGRAMMENI,
        UNICODE_OMEGA_VARIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_YPOGERGRAMMENI,
        UNICODE_OMEGA_OXIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_PERISPOMENI,
        UNICODE_OMEGA_PERISPOMENI_YPOGERGRAMMENI
    };
    return createSet(omegaChars,sizeof(omegaChars));
}

+(NSCharacterSet*)createRhoVariantCharSet {
    //NSLog(@"Creating rho set...");
    UniChar rhoChars[] = {
        //RHO,
        UNICODE_RHO_PSILI,
        UNICODE_RHO_DASIA
    };
    return createSet(rhoChars,sizeof(rhoChars));
}

+(NSCharacterSet*)createPlainGreekCharSet {
    //NSLog(@"Creating plain greek set...");
    UniChar plaingreekChars[] = {
        UNICODE_ALPHA,
        UNICODE_EPSILON,
        UNICODE_ETA,
        UNICODE_IOTA,
        UNICODE_OMICRON,
        UNICODE_UPSILON,
        UNICODE_OMEGA,
        UNICODE_RHO,
        
        UNICODE_BETA,
        UNICODE_GAMMA,
        UNICODE_DELTA,
        UNICODE_ZETA,
        UNICODE_THETA,
        UNICODE_KAPPA,
        UNICODE_LAMBDA,
        UNICODE_MI,
        UNICODE_NI,
        UNICODE_XI,
        UNICODE_PI,
        UNICODE_SIGMA_FINAL,
        UNICODE_SIGMA,
        UNICODE_TAU,
        UNICODE_PHI,
        UNICODE_CHI,
        UNICODE_PSI,
        UNICODE_DIGAMMA
    };
    return createSet(plaingreekChars,sizeof(plaingreekChars));
}

    /*
+(NSCharacterSet*)createPolytonicGreekCharSet {
    //NSLog(@"Creating polytonic greek set...");
    UniChar polytonicgreekChars[] = {
        UNICODE_ALPHA,
        UNICODE_ALPHA_PSILI,
        UNICODE_ALPHA_DASIA,
        UNICODE_ALPHA_PSILI_VARIA,
        UNICODE_ALPHA_DASIA_VARIA,
        UNICODE_ALPHA_PSILI_OXIA,
        UNICODE_ALPHA_DASIA_OXIA,
        UNICODE_ALPHA_PSILI_PERISPOMENI,
        UNICODE_ALPHA_DASIA_PERISPOMENI,
        UNICODE_ALPHA_VARIA,
        UNICODE_ALPHA_OXIA,
        UNICODE_ALPHA_PSILI_YPOGERGRAMMENI,
        UNICODE_ALPHA_DASIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_PSILI_VARIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_DASIA_VARIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_PSILI_OXIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_DASIA_OXIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_PSILI_PERISPOMENI_YPOGERGRAMMENI,
        UNICODE_ALPHA_DASIA_PERISPOMENI_YPOGERGRAMMENI,
        UNICODE_ALPHA_VARIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_YPOGERGRAMMENI,
        UNICODE_ALPHA_OXIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_PERISPOMENI,
        UNICODE_ALPHA_PERISPOMENI_YPOGERGRAMMENI,
        
        UNICODE_EPSILON,
        UNICODE_EPSILON_PSILI,
        UNICODE_EPSILON_DASIA,
        UNICODE_EPSILON_PSILI_VARIA,
        UNICODE_EPSILON_DASIA_VARIA,
        UNICODE_EPSILON_PSILI_OXIA,
        UNICODE_EPSILON_DASIA_OXIA,
        UNICODE_EPSILON_VARIA,
        UNICODE_EPSILON_OXIA,
        
        UNICODE_ETA,
        UNICODE_ETA_PSILI,
        UNICODE_ETA_DASIA,
        UNICODE_ETA_PSILI_VARIA,
        UNICODE_ETA_DASIA_VARIA,
        UNICODE_ETA_PSILI_OXIA,
        UNICODE_ETA_DASIA_OXIA,
        UNICODE_ETA_PSILI_PERISPOMENI,
        UNICODE_ETA_DASIA_PERISPOMENI,
        UNICODE_ETA_VARIA,
        UNICODE_ETA_OXIA,
        UNICODE_ETA_PSILI_YPOGERGRAMMENI,
        UNICODE_ETA_DASIA_YPOGERGRAMMENI,
        UNICODE_ETA_PSILI_VARIA_YPOGERGRAMMENI,
        UNICODE_ETA_DASIA_VARIA_YPOGERGRAMMENI,
        UNICODE_ETA_PSILI_OXIA_YPOGERGRAMMENI,
        UNICODE_ETA_DASIA_OXIA_YPOGERGRAMMENI,
        UNICODE_ETA_PSILI_PERISPOMENI_YPOGERGRAMMENI,
        UNICODE_ETA_DASIA_PERISPOMENI_YPOGERGRAMMENI,
        UNICODE_ETA_VARIA_YPOGERGRAMMENI,
        UNICODE_ETA_YPOGERGRAMMENI,
        UNICODE_ETA_OXIA_YPOGERGRAMMENI,
        UNICODE_ETA_PERISPOMENI,
        UNICODE_ETA_PERISPOMENI_YPOGERGRAMMENI,
        
        UNICODE_IOTA,
        UNICODE_IOTA_PSILI,
        UNICODE_IOTA_DASIA,
        UNICODE_IOTA_PSILI_VARIA,
        UNICODE_IOTA_DASIA_VARIA,
        UNICODE_IOTA_PSILI_OXIA,
        UNICODE_IOTA_DASIA_OXIA,
        UNICODE_IOTA_PSILI_PERISPOMENI,
        UNICODE_IOTA_DASIA_PERISPOMENI,
        UNICODE_IOTA_VARIA,
        UNICODE_IOTA_OXIA,
        UNICODE_IOTA_PERISPOMENI,
        
        UNICODE_OMICRON,
        UNICODE_OMICRON_PSILI,
        UNICODE_OMICRON_DASIA,
        UNICODE_OMICRON_PSILI_VARIA,
        UNICODE_OMICRON_DASIA_VARIA,
        UNICODE_OMICRON_PSILI_OXIA,
        UNICODE_OMICRON_DASIA_OXIA,
        UNICODE_OMICRON_VARIA,
        UNICODE_OMICRON_OXIA,
        
        UNICODE_UPSILON,
        UNICODE_UPSILON_PSILI,
        UNICODE_UPSILON_DASIA,
        UNICODE_UPSILON_PSILI_VARIA,
        UNICODE_UPSILON_DASIA_VARIA,
        UNICODE_UPSILON_PSILI_OXIA,
        UNICODE_UPSILON_DASIA_OXIA,
        UNICODE_UPSILON_PSILI_PERISPOMENI,
        UNICODE_UPSILON_DASIA_PERISPOMENI,
        UNICODE_UPSILON_VARIA,
        UNICODE_UPSILON_OXIA,
        UNICODE_UPSILON_PERISPOMENI,
        
        UNICODE_OMEGA,
        UNICODE_OMEGA_PSILI,
        UNICODE_OMEGA_DASIA,
        UNICODE_OMEGA_PSILI_VARIA,
        UNICODE_OMEGA_DASIA_VARIA,
        UNICODE_OMEGA_PSILI_OXIA,
        UNICODE_OMEGA_DASIA_OXIA,
        UNICODE_OMEGA_PSILI_PERISPOMENI,
        UNICODE_OMEGA_DASIA_PERISPOMENI,
        UNICODE_OMEGA_VARIA,
        UNICODE_OMEGA_OXIA,
        UNICODE_OMEGA_PSILI_YPOGERGRAMMENI,
        UNICODE_OMEGA_DASIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_PSILI_VARIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_DASIA_VARIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_PSILI_OXIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_DASIA_OXIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_PSILI_PERISPOMENI_YPOGERGRAMMENI,
        UNICODE_OMEGA_DASIA_PERISPOMENI_YPOGERGRAMMENI,
        UNICODE_OMEGA_VARIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_YPOGERGRAMMENI,
        UNICODE_OMEGA_OXIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_PERISPOMENI,
        UNICODE_OMEGA_PERISPOMENI_YPOGERGRAMMENI,
        
        UNICODE_RHO,
        //           UNICODE_RHO_PSILI,
        UNICODE_RHO_DASIA,
        
        UNICODE_BETA,
        UNICODE_GAMMA,
        UNICODE_DELTA,
        UNICODE_ZETA,
        UNICODE_THETA,
        UNICODE_KAPPA,
        UNICODE_LAMBDA,
        UNICODE_MI,
        UNICODE_NI,
        UNICODE_XI,
        UNICODE_PI,
        UNICODE_SIGMA_FINAL,
        UNICODE_SIGMA,
        UNICODE_TAU,
        UNICODE_PHI,
        UNICODE_CHI,
        UNICODE_PSI,
        
        UNICODE_DIGAMMA
    };
    return createSet(polytonicgreekChars,sizeof(polytonicgreekChars));
}*/

    /*
+(NSCharacterSet*)createPhilologicalGreekCharSet {
    //NSLog(@"Creating philological greek set...");
    UniChar philologicalgreekChars[] = {
        UNICODE_ALPHA,
        UNICODE_ALPHA_PSILI,
        UNICODE_ALPHA_DASIA,
        UNICODE_ALPHA_PSILI_VARIA,
        UNICODE_ALPHA_DASIA_VARIA,
        UNICODE_ALPHA_PSILI_OXIA,
        UNICODE_ALPHA_DASIA_OXIA,
        UNICODE_ALPHA_PSILI_PERISPOMENI,
        UNICODE_ALPHA_DASIA_PERISPOMENI,
        UNICODE_ALPHA_VARIA,
        UNICODE_ALPHA_OXIA,
        UNICODE_ALPHA_PSILI_YPOGERGRAMMENI,
        UNICODE_ALPHA_DASIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_PSILI_VARIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_DASIA_VARIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_PSILI_OXIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_DASIA_OXIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_PSILI_PERISPOMENI_YPOGERGRAMMENI,
        UNICODE_ALPHA_DASIA_PERISPOMENI_YPOGERGRAMMENI,
        UNICODE_ALPHA_VRACHY,
        UNICODE_ALPHA_MACRON,
        UNICODE_ALPHA_VARIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_YPOGERGRAMMENI,
        UNICODE_ALPHA_OXIA_YPOGERGRAMMENI,
        UNICODE_ALPHA_PERISPOMENI,
        UNICODE_ALPHA_PERISPOMENI_YPOGERGRAMMENI,
        UNICODE_ALPHA_MACRON_OXIA,
        UNICODE_ALPHA_MACRON_PSILI,
        UNICODE_ALPHA_MACRON_DASIA,
        UNICODE_ALPHA_VRACHY_OXIA,
        
        UNICODE_EPSILON,
        UNICODE_EPSILON_PSILI,
        UNICODE_EPSILON_DASIA,
        UNICODE_EPSILON_PSILI_VARIA,
        UNICODE_EPSILON_DASIA_VARIA,
        UNICODE_EPSILON_PSILI_OXIA,
        UNICODE_EPSILON_DASIA_OXIA,
        UNICODE_EPSILON_VARIA,
        UNICODE_EPSILON_OXIA,
        
        UNICODE_ETA,
        UNICODE_ETA_PSILI,
        UNICODE_ETA_DASIA,
        UNICODE_ETA_PSILI_VARIA,
        UNICODE_ETA_DASIA_VARIA,
        UNICODE_ETA_PSILI_OXIA,
        UNICODE_ETA_DASIA_OXIA,
        UNICODE_ETA_PSILI_PERISPOMENI,
        UNICODE_ETA_DASIA_PERISPOMENI,
        UNICODE_ETA_VARIA,
        UNICODE_ETA_OXIA,
        UNICODE_ETA_PSILI_YPOGERGRAMMENI,
        UNICODE_ETA_DASIA_YPOGERGRAMMENI,
        UNICODE_ETA_PSILI_VARIA_YPOGERGRAMMENI,
        UNICODE_ETA_DASIA_VARIA_YPOGERGRAMMENI,
        UNICODE_ETA_PSILI_OXIA_YPOGERGRAMMENI,
        UNICODE_ETA_DASIA_OXIA_YPOGERGRAMMENI,
        UNICODE_ETA_PSILI_PERISPOMENI_YPOGERGRAMMENI,
        UNICODE_ETA_DASIA_PERISPOMENI_YPOGERGRAMMENI,
        UNICODE_ETA_VARIA_YPOGERGRAMMENI,
        UNICODE_ETA_YPOGERGRAMMENI,
        UNICODE_ETA_OXIA_YPOGERGRAMMENI,
        UNICODE_ETA_PERISPOMENI,
        UNICODE_ETA_PERISPOMENI_YPOGERGRAMMENI,
        
        UNICODE_IOTA,
        UNICODE_IOTA_PSILI,
        UNICODE_IOTA_DASIA,
        UNICODE_IOTA_PSILI_VARIA,
        UNICODE_IOTA_DASIA_VARIA,
        UNICODE_IOTA_PSILI_OXIA,
        UNICODE_IOTA_DASIA_OXIA,
        UNICODE_IOTA_PSILI_PERISPOMENI,
        UNICODE_IOTA_DASIA_PERISPOMENI,
        UNICODE_IOTA_VARIA,
        UNICODE_IOTA_OXIA,
        UNICODE_IOTA_VRACHY,
        UNICODE_IOTA_MACRON,
        UNICODE_IOTA_DIALYTIKA_VARIA,
        UNICODE_IOTA_DIALYTIKA_OXIA,
        UNICODE_IOTA_PERISPOMENI,
        UNICODE_IOTA_MACRON_OXIA,
        UNICODE_IOTA_DIALYTIKA,
        
        UNICODE_OMICRON,
        UNICODE_OMICRON_PSILI,
        UNICODE_OMICRON_DASIA,
        UNICODE_OMICRON_PSILI_VARIA,
        UNICODE_OMICRON_DASIA_VARIA,
        UNICODE_OMICRON_PSILI_OXIA,
        UNICODE_OMICRON_DASIA_OXIA,
        UNICODE_OMICRON_VARIA,
        UNICODE_OMICRON_OXIA,
        
        UNICODE_UPSILON,
        UNICODE_UPSILON_PSILI,
        UNICODE_UPSILON_DASIA,
        UNICODE_UPSILON_PSILI_VARIA,
        UNICODE_UPSILON_DASIA_VARIA,
        UNICODE_UPSILON_PSILI_OXIA,
        UNICODE_UPSILON_DASIA_OXIA,
        UNICODE_UPSILON_PSILI_PERISPOMENI,
        UNICODE_UPSILON_DASIA_PERISPOMENI,
        UNICODE_UPSILON_VARIA,
        UNICODE_UPSILON_OXIA,
        UNICODE_UPSILON_VRACHY,
        UNICODE_UPSILON_MACRON,
        UNICODE_UPSILON_PERISPOMENI,
        
        UNICODE_OMEGA,
        UNICODE_OMEGA_PSILI,
        UNICODE_OMEGA_DASIA,
        UNICODE_OMEGA_PSILI_VARIA,
        UNICODE_OMEGA_DASIA_VARIA,
        UNICODE_OMEGA_PSILI_OXIA,
        UNICODE_OMEGA_DASIA_OXIA,
        UNICODE_OMEGA_PSILI_PERISPOMENI,
        UNICODE_OMEGA_DASIA_PERISPOMENI,
        UNICODE_OMEGA_VARIA,
        UNICODE_OMEGA_OXIA,
        UNICODE_OMEGA_PSILI_YPOGERGRAMMENI,
        UNICODE_OMEGA_DASIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_PSILI_VARIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_DASIA_VARIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_PSILI_OXIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_DASIA_OXIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_PSILI_PERISPOMENI_YPOGERGRAMMENI,
        UNICODE_OMEGA_DASIA_PERISPOMENI_YPOGERGRAMMENI,
        UNICODE_OMEGA_VARIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_YPOGERGRAMMENI,
        UNICODE_OMEGA_OXIA_YPOGERGRAMMENI,
        UNICODE_OMEGA_PERISPOMENI,
        UNICODE_OMEGA_PERISPOMENI_YPOGERGRAMMENI,
        
        UNICODE_RHO,
        UNICODE_RHO_DASIA,
        
        UNICODE_BETA,
        UNICODE_GAMMA,
        UNICODE_DELTA,
        UNICODE_ZETA,
        UNICODE_THETA,
        UNICODE_KAPPA,
        UNICODE_LAMBDA,
        UNICODE_MI,
        UNICODE_NI,
        UNICODE_XI,
        UNICODE_PI,
        UNICODE_SIGMA_FINAL,
        UNICODE_SIGMA,
        UNICODE_TAU,
        UNICODE_PHI,
        UNICODE_CHI,
        UNICODE_PSI,
        
    };
    return createSet(philologicalgreekChars,sizeof(philologicalgreekChars));
}
     */
    
    
+(NSCharacterSet*)createAsciiLetterGreekCharSet {
    //NSLog(@"Creating ascii letter set...");
    UniChar asciiLetterChars[] = {
        'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z',
        'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'
        
    };
    return createSet(asciiLetterChars,sizeof(asciiLetterChars));
}

@end
