//
//  ilRocciFontset.h
//  VerbiGreci
//
//  Created by Claudio Capobianco on 13/04/12.
//  Copyright (c) 2012 Librum. All rights reserved.
//

#ifndef ilRocciFontset_h
#define ilRocciFontset_h


// PSILI: spirito dolce  )
// DASIA: spirito aspro (
// VARIA: accento grave \
// OXIA:  accento acuto /
// PERISPOMENI:accento circonflesso ~
// YPOGERGRAMMENI: iota sottoscritto 
// VRACHY (o BREVE): accento breve
// MACRON: accento lungo
// DIALYTIKA: dieresi
// CIRCUMFLEX: ^
// BREVE 

enum ilRocciFontset {
    
    ILROCCI_NONE = 0x0000,
    
    ILROCCI_ALPHA = 0x0261,
    ILROCCI_ALPHA_PSILI = 0x0283,
    ILROCCI_ALPHA_DASIA = 0x0282,
    ILROCCI_ALPHA_PSILI_VARIA = 0x0287,
    ILROCCI_ALPHA_DASIA_VARIA = 0x0285,
    ILROCCI_ALPHA_PSILI_OXIA = 0x0286,
    ILROCCI_ALPHA_DASIA_OXIA = 0x0284,
    ILROCCI_ALPHA_PSILI_PERISPOMENI = 0x0288,
    ILROCCI_ALPHA_DASIA_PERISPOMENI = 0x0289,
    ILROCCI_ALPHA_VARIA = 0x0281,
    ILROCCI_ALPHA_OXIA = 0x0280,
    ILROCCI_ALPHA_PSILI_YPOGERGRAMMENI = 0x0290,
    ILROCCI_ALPHA_DASIA_YPOGERGRAMMENI = 0x0291,
    ILROCCI_ALPHA_PSILI_VARIA_YPOGERGRAMMENI = 0x0292,
    ILROCCI_ALPHA_DASIA_VARIA_YPOGERGRAMMENI = 0x0293,
    ILROCCI_ALPHA_PSILI_OXIA_YPOGERGRAMMENI = 0x0294,
    ILROCCI_ALPHA_DASIA_OXIA_YPOGERGRAMMENI = 0x0295,
    ILROCCI_ALPHA_PSILI_PERISPOMENI_YPOGERGRAMMENI = 0x0296,
    ILROCCI_ALPHA_DASIA_PERISPOMENI_YPOGERGRAMMENI = 0x0297,
    ILROCCI_ALPHA_VRACHY = 0x028C,
    ILROCCI_ALPHA_MACRON = 0x028D,
    ILROCCI_ALPHA_VARIA_YPOGERGRAMMENI = 0x0298,
    ILROCCI_ALPHA_YPOGERGRAMMENI = 0x028E,
    ILROCCI_ALPHA_OXIA_YPOGERGRAMMENI = 0x0299,
    ILROCCI_ALPHA_PERISPOMENI = 0x028B,
    ILROCCI_ALPHA_PERISPOMENI_YPOGERGRAMMENI = 0x028F,
    ILROCCI_ALPHA_MACRON_OXIA = 0x029A,
    ILROCCI_ALPHA_MACRON_PSILI = 0x02DF,
    ILROCCI_ALPHA_MACRON_DASIA = 0x027F,
    ILROCCI_ALPHA_VRACHY_OXIA = 0x023E,

    
    ILROCCI_EPSILON = 0x0265,
    ILROCCI_EPSILON_PSILI = 0x029F,
    ILROCCI_EPSILON_DASIA = 0x029E,
    ILROCCI_EPSILON_PSILI_VARIA = 0x02A3,
    ILROCCI_EPSILON_DASIA_VARIA = 0x02A1,
    ILROCCI_EPSILON_PSILI_OXIA = 0x02A2,
    ILROCCI_EPSILON_DASIA_OXIA = 0x023B,
    ILROCCI_EPSILON_VARIA = 0x029D,
    ILROCCI_EPSILON_OXIA = 0x029C,
    
    ILROCCI_ETA = 0x0267,
    ILROCCI_ETA_PSILI = 0x0224,
    ILROCCI_ETA_DASIA = 0x0223,
    ILROCCI_ETA_PSILI_VARIA = 0x0228,
    ILROCCI_ETA_DASIA_VARIA = 0x0226,
    ILROCCI_ETA_PSILI_OXIA = 0x0227,
    ILROCCI_ETA_DASIA_OXIA = 0x0225,
    ILROCCI_ETA_PSILI_PERISPOMENI = 0x0229,
    ILROCCI_ETA_DASIA_PERISPOMENI = 0x022A,
    ILROCCI_ETA_VARIA = 0x0222,
    ILROCCI_ETA_OXIA = 0x0221,
    ILROCCI_ETA_PSILI_YPOGERGRAMMENI = 0x022E,
    ILROCCI_ETA_DASIA_YPOGERGRAMMENI = 0x022F,
    ILROCCI_ETA_PSILI_VARIA_YPOGERGRAMMENI = 0x0230,
    ILROCCI_ETA_DASIA_VARIA_YPOGERGRAMMENI = 0x0231,
    ILROCCI_ETA_PSILI_OXIA_YPOGERGRAMMENI = 0x0232,
    ILROCCI_ETA_DASIA_OXIA_YPOGERGRAMMENI = 0x0233,
    ILROCCI_ETA_PSILI_PERISPOMENI_YPOGERGRAMMENI = 0x0234,
    ILROCCI_ETA_DASIA_PERISPOMENI_YPOGERGRAMMENI = 0x0235,
    ILROCCI_ETA_VARIA_YPOGERGRAMMENI = 0x0236,
    ILROCCI_ETA_YPOGERGRAMMENI = 0x022C,
    ILROCCI_ETA_OXIA_YPOGERGRAMMENI = 0x0237,
    ILROCCI_ETA_PERISPOMENI = 0x025A,
    ILROCCI_ETA_PERISPOMENI_YPOGERGRAMMENI = 0x0238,
    
    ILROCCI_IOTA = 0x0269,
    ILROCCI_IOTA_PSILI = 0x02A9,
    ILROCCI_IOTA_DASIA = 0x02A8,
    ILROCCI_IOTA_PSILI_VARIA = 0x02AD,
    ILROCCI_IOTA_DASIA_VARIA = 0x02AB,
    ILROCCI_IOTA_PSILI_OXIA = 0x02AC,
    ILROCCI_IOTA_DASIA_OXIA = 0x02AA,
    ILROCCI_IOTA_PSILI_PERISPOMENI = 0x02B1,
    ILROCCI_IOTA_DASIA_PERISPOMENI = 0x02B2,
    ILROCCI_IOTA_VARIA = 0x02A7,
    ILROCCI_IOTA_OXIA = 0x02A6,
    ILROCCI_IOTA_VRACHY = 0x02B6,
    ILROCCI_IOTA_VRACHY_OXIA = 0x023A,
    ILROCCI_IOTA_MACRON = 0x02B7,
    ILROCCI_IOTA_MACRON_OXIA = 0x02A5,
    ILROCCI_IOTA_DIALYTIKA_VARIA = 0x02B4,
    ILROCCI_IOTA_DIALYTIKA_OXIA = 0x02B3,
    ILROCCI_IOTA_PERISPOMENI = 0x02B0,
    ILROCCI_IOTA_DIALYTIKA = 0x02AF,
    
    ILROCCI_OMICRON = 0x026F,
    ILROCCI_OMICRON_PSILI = 0x02bc,
    ILROCCI_OMICRON_DASIA = 0x02bb,
    ILROCCI_OMICRON_PSILI_VARIA = 0x02c0,
    ILROCCI_OMICRON_DASIA_VARIA = 0x02be,
    ILROCCI_OMICRON_PSILI_OXIA = 0x02bf,
    ILROCCI_OMICRON_DASIA_OXIA = 0x02bd,
    ILROCCI_OMICRON_VARIA = 0x02ba,
    ILROCCI_OMICRON_OXIA = 0x02b9,
    
    
    
    ILROCCI_UPSILON = 0x0275,
    ILROCCI_UPSILON_PSILI = 0x02C7,
    ILROCCI_UPSILON_DASIA = 0x02C6,
    ILROCCI_UPSILON_PSILI_VARIA = 0x02CB,
    ILROCCI_UPSILON_DASIA_VARIA = 0x02C9,
    ILROCCI_UPSILON_PSILI_OXIA = 0x02CA,
    ILROCCI_UPSILON_DASIA_OXIA = 0x02C8,
    ILROCCI_UPSILON_PSILI_PERISPOMENI = 0x02CD,
    ILROCCI_UPSILON_DASIA_PERISPOMENI = 0x02CE,
    ILROCCI_UPSILON_VARIA = 0x02C5,
    ILROCCI_UPSILON_OXIA = 0x02C4,
    ILROCCI_UPSILON_VRACHY = 0x02D4,
    ILROCCI_UPSILON_MACRON = 0x02D5,
    ILROCCI_UPSILON_VARIA_DIALYTIKA = 0x02D3,
	ILROCCI_UPSILON_DIALYTIKA = 0x02D1,
    ILROCCI_UPSILON_PERISPOMENI = 0x02CC,
    ILROCCI_UPSILON_VRACHY_OXIA = 0x02CF,
    ILROCCI_UPSILON_MACRON_OXIA = 0x0240,
    ILROCCI_UPSILON_OXIA_DIALYTIKA = 0x02D2,
    
    ILROCCI_OMEGA = 0x0279,
    ILROCCI_OMEGA_PSILI = 0x02DA,
    ILROCCI_OMEGA_DASIA = 0x02D9,
    ILROCCI_OMEGA_PSILI_VARIA = 0x02DE,
    ILROCCI_OMEGA_DASIA_VARIA = 0x02DC,
    ILROCCI_OMEGA_PSILI_OXIA = 0x02DD,
    ILROCCI_OMEGA_DASIA_OXIA = 0x02DB,
    ILROCCI_OMEGA_PSILI_PERISPOMENI = 0x02E1,
    ILROCCI_OMEGA_DASIA_PERISPOMENI = 0x02E2,
    ILROCCI_OMEGA_VARIA = 0x02D8,
    ILROCCI_OMEGA_OXIA = 0x02D7,
    ILROCCI_OMEGA_PSILI_YPOGERGRAMMENI = 0x02E4,
    ILROCCI_OMEGA_DASIA_YPOGERGRAMMENI = 0x02E5,
    ILROCCI_OMEGA_PSILI_VARIA_YPOGERGRAMMENI = 0x02E6,
    ILROCCI_OMEGA_DASIA_VARIA_YPOGERGRAMMENI = 0x02E7,
    ILROCCI_OMEGA_PSILI_OXIA_YPOGERGRAMMENI = 0x02E8,
    ILROCCI_OMEGA_DASIA_OXIA_YPOGERGRAMMENI = 0x02E9,
    ILROCCI_OMEGA_PSILI_PERISPOMENI_YPOGERGRAMMENI = 0x02EA,
    ILROCCI_OMEGA_DASIA_PERISPOMENI_YPOGERGRAMMENI = 0x02EB,
    ILROCCI_OMEGA_VARIA_YPOGERGRAMMENI = 0x02EC,
    ILROCCI_OMEGA_YPOGERGRAMMENI = 0x02E3,
    ILROCCI_OMEGA_OXIA_YPOGERGRAMMENI = 0x02ED,
    ILROCCI_OMEGA_PERISPOMENI = 0x02E0,
    ILROCCI_OMEGA_PERISPOMENI_YPOGERGRAMMENI = 0x02EE,
    
    ILROCCI_RHO = 0x0271,
    ILROCCI_RHO_DASIA = 0x02C2,
    
    ILROCCI_BETA = 0x0262, 
    ILROCCI_GAMMA = 0x0263, 
    ILROCCI_DELTA = 0x0264, 
    ILROCCI_ZETA = 0x0266, 
    ILROCCI_THETA = 0x0268, 
    ILROCCI_KAPPA = 0x026A, 
    ILROCCI_LAMBDA = 0x026B, 
    ILROCCI_MI = 0x026C, 
    ILROCCI_NI = 0x026D, 
    ILROCCI_XI = 0x026E, 
    ILROCCI_PI = 0x0270, 
    ILROCCI_SIGMA_FINAL = 0x0272, 
    ILROCCI_SIGMA = 0x0273, 
    ILROCCI_TAU = 0x0274, 
    ILROCCI_PHI = 0x0276, 
    ILROCCI_CHI = 0x0277, 
    ILROCCI_PSI = 0x0278, 
    
    ILROCCI_DIGAMMA = 0x027A,
    
    
    /* CAPITAL LETTERS */
    ILROCCI_CAPITAL_ALPHA = 0x0241,
    ILROCCI_CAPITAL_ALPHA_PSILI = 0x022B,
    ILROCCI_CAPITAL_ALPHA_DASIA = 0x02A4,
    ILROCCI_CAPITAL_ALPHA_PSILI_VARIA = 0x029B,
    ILROCCI_CAPITAL_ALPHA_DASIA_VARIA = 0x0327,
    ILROCCI_CAPITAL_ALPHA_PSILI_OXIA = 0x0328,
    ILROCCI_CAPITAL_ALPHA_DASIA_OXIA = 0x0329,
    ILROCCI_CAPITAL_ALPHA_PSILI_PERISPOMENI = 0x032A,
    ILROCCI_CAPITAL_ALPHA_DASIA_PERISPOMENI = 0x032B,
    ILROCCI_CAPITAL_ALPHA_VARIA = 0x00C0,
    ILROCCI_CAPITAL_ALPHA_OXIA = 0x00C1,
    ILROCCI_CAPITAL_ALPHA_VRACHY = 0x032C,
    ILROCCI_CAPITAL_ALPHA_MACRON = 0x035A,
    ILROCCI_CAPITAL_ALPHA_PERISPOMENI = 0x00C3,
    
    ILROCCI_CAPITAL_BETA = 0x0242,
    ILROCCI_CAPITAL_GAMMA = 0x0243,
    ILROCCI_CAPITAL_DELTA = 0x0244,
    
    ILROCCI_CAPITAL_EPSILON = 0x0245,
    ILROCCI_CAPITAL_EPSILON_PSILI = 0x02AE,
    ILROCCI_CAPITAL_EPSILON_DASIA = 0x02C1,
    ILROCCI_CAPITAL_EPSILON_PSILI_VARIA = 0x0394,
    ILROCCI_CAPITAL_EPSILON_DASIA_VARIA = 0x0395,
    ILROCCI_CAPITAL_EPSILON_PSILI_OXIA = 0x0396,
    ILROCCI_CAPITAL_EPSILON_DASIA_OXIA = 0x0397,
      
    ILROCCI_CAPITAL_ZETA = 0x0246,
    
    ILROCCI_CAPITAL_ETA = 0x0247,
    ILROCCI_CAPITAL_ETA_PSILI = 0x0239,
    ILROCCI_CAPITAL_ETA_DASIA = 0x023F,
    ILROCCI_CAPITAL_ETA_PSILI_VARIA = 0x033E,
    ILROCCI_CAPITAL_ETA_DASIA_VARIA = 0x033F,
    ILROCCI_CAPITAL_ETA_PSILI_OXIA = 0x0340,
    ILROCCI_CAPITAL_ETA_DASIA_OXIA = 0x0341,
    ILROCCI_CAPITAL_ETA_PSILI_PERISPOMENI = 0x0342,
    ILROCCI_CAPITAL_ETA_DASIA_PERISPOMENI = 0x0343,
     
    ILROCCI_CAPITAL_THETA = 0x0248,
    
    ILROCCI_CAPITAL_IOTA = 0x0249,
    ILROCCI_CAPITAL_IOTA_PSILI = 0x0253,
    ILROCCI_CAPITAL_IOTA_DASIA = 0x028A,
    ILROCCI_CAPITAL_IOTA_PSILI_VARIA = 0x0360,
    ILROCCI_CAPITAL_IOTA_DASIA_VARIA = 0x0361,
    ILROCCI_CAPITAL_IOTA_PSILI_OXIA = 0x0362,
    ILROCCI_CAPITAL_IOTA_DASIA_OXIA = 0x0363,
    ILROCCI_CAPITAL_IOTA_PSILI_PERISPOMENI = 0x0364,
    ILROCCI_CAPITAL_IOTA_DASIA_PERISPOMENI = 0x0365,
      
    ILROCCI_CAPITAL_KAPPA = 0x024a,
    ILROCCI_CAPITAL_LAMBDA = 0x024b,
    ILROCCI_CAPITAL_MI = 0x024c,
    ILROCCI_CAPITAL_NI = 0x024d,
    ILROCCI_CAPITAL_XI = 0x024e,
    
    ILROCCI_CAPITAL_OMICRON = 0x024f,
    ILROCCI_CAPITAL_OMICRON_PSILI = 0x02B5,
    ILROCCI_CAPITAL_OMICRON_DASIA = 0x02B8,
    ILROCCI_CAPITAL_OMICRON_PSILI_VARIA = 0x036D,
    ILROCCI_CAPITAL_OMICRON_DASIA_VARIA = 0x036E,
    ILROCCI_CAPITAL_OMICRON_PSILI_OXIA = 0x036F,
    ILROCCI_CAPITAL_OMICRON_DASIA_OXIA = 0x0370,
    
    ILROCCI_CAPITAL_PI = 0x0250,
    
    ILROCCI_CAPITAL_RHO = 0x0251,
    ILROCCI_CAPITAL_RHO_DASIA = 0x02D6,
    
    ILROCCI_CAPITAL_SIGMA = 0x0252,
    ILROCCI_CAPITAL_TAU = 0x0254,
    
    ILROCCI_CAPITAL_UPSILON = 0x0255,
    ILROCCI_CAPITAL_UPSILON_DASIA = 0x0376,
    ILROCCI_CAPITAL_UPSILON_DASIA_VARIA = 0x0377,
    ILROCCI_CAPITAL_UPSILON_DASIA_OXIA = 0x0378,
    ILROCCI_CAPITAL_UPSILON_DASIA_PERISPOMENI = 0x0379,
    ILROCCI_CAPITAL_UPSILON_VRACHY = 0x037A,
    ILROCCI_CAPITAL_UPSILON_MACRON = 0x037B,
    
    ILROCCI_CAPITAL_PHI = 0x0256,
    ILROCCI_CAPITAL_CHI = 0x0257,
    ILROCCI_CAPITAL_PSI = 0x0258,
    
    ILROCCI_CAPITAL_OMEGA = 0x0259,
    ILROCCI_CAPITAL_OMEGA_PSILI = 0x02C3,
    ILROCCI_CAPITAL_OMEGA_DASIA = 0x02D0,
    ILROCCI_CAPITAL_OMEGA_PSILI_VARIA = 0x03A3,
    ILROCCI_CAPITAL_OMEGA_DASIA_VARIA = 0x03A4,
    ILROCCI_CAPITAL_OMEGA_PSILI_OXIA = 0x03A5,
    ILROCCI_CAPITAL_OMEGA_DASIA_OXIA = 0x03A6,
    ILROCCI_CAPITAL_OMEGA_PSILI_PERISPOMENI = 0x03A7,
    ILROCCI_CAPITAL_OMEGA_DASIA_PERISPOMENI = 0x03A8,
    
    // Signs
    ILROCCI_SIGN_PSILI = 0x02FC,
    ILROCCI_SIGN_DASIA = 0x02FD,
    ILROCCI_SIGN_VARIA = 0x02FF,
    ILROCCI_SIGN_OXIA = 0x02FE,
    ILROCCI_SIGN_PERISPOMENI = 0x02FA,
    ILROCCI_SIGN_YPOGERGRAMMENI = 0x02FB,
    
    // Punctuation
    ILROCCI_PUNCT_SPACE = 0x0220,
    ILROCCI_PUNCT_PARENTHESES_OPEN = 0x02EF,
    ILROCCI_PUNCT_PARENTHESES_CLOSE = 0x02F0,
    ILROCCI_PUNCT_DOT = 0x025B,
    ILROCCI_PUNCT_DASH = 0x022D,
    ILROCCI_PUNCT_COMMA = 0x027E,
    ILROCCI_PUNCT_ELLIPSIS = 0X00A4,
    ILROCCI_PUNCT_COLON = 0X025D,
    ILROCCI_PUNCT_SEMICOLON = 0X025E,
    ILROCCI_PUNCT_QUESTION_MARK = 0X025F,
    ILROCCI_PUNCT_EXCLAMATION_MARK = 0X0260,
    ILROCCI_PUNCT_SLASH = 0X025C,
    ILROCCI_PUNCT_PERMIL = 0x0089,
    ILROCCI_PUNCT_LONG_DASH = 0X00AE,
    ILROCCI_PUNCT_XXL_DASH = 0x0097,
    ILROCCI_PUNCT_DQUOTE_OPEN = 0x00A9,
    
    ILROCCI_ACCENT_ACUTE = 0x02F3,
    ILROCCI_ACCENT_ACUTE_LOW = 0x02F2, // FIXME find correct name
    ILROCCI_ACCENT_SMOOTH = 0x00A7,
    
    ILROCCI_LATIN_S_CARON = 0x0040,
    
    //FIXME TODO: replace EXTRA_xx with a verbose name
    ILROCCI_EXTRA_01 = 0x023C, // low line
    ILROCCI_EXTRA_02 = 0x023D, // equal
    ILROCCI_EXTRA_03 = 0x027B, // bottom half O
    ILROCCI_EXTRA_04 = 0x027C, // qoppa
    ILROCCI_EXTRA_05 = 0x027D, // long greek pi
    ILROCCI_EXTRA_06 = 0x02F1, // semicolon
    ILROCCI_EXTRA_07 = 0x02F4, // below central apice
    ILROCCI_EXTRA_08 = 0x02F5, // above central apice
    ILROCCI_EXTRA_09 = 0x02F6, // apice dieresi
    ILROCCI_EXTRA_10 = 0x02F7, // above dot
    ILROCCI_EXTRA_11 = 0x02F8, // dieresi perispomeni
    ILROCCI_EXTRA_12 = 0x02F9, // high star
    ILROCCI_EXTRA_13 = 0x0374, // P with X
    ILROCCI_EXTRA_14 = 0x0375, // X with four dots
    ILROCCI_EXTRA_15 = 0x0381, // n with breve below
    ILROCCI_EXTRA_16 = 0x0382, // h with wing below
    ILROCCI_EXTRA_17 = 0x0383, // l with ring below
    ILROCCI_EXTRA_18 = 0x0384, // m with ring below
    ILROCCI_EXTRA_19 = 0x0385, // n with ring below
    ILROCCI_EXTRA_20 = 0x0386, // r with ring below
    ILROCCI_EXTRA_21 = 0x0387, // h with breve below
    ILROCCI_EXTRA_22 = 0x0388, // s with breve below
    ILROCCI_EXTRA_23 = 0x0389, // s with caron
    ILROCCI_EXTRA_24 = 0x038A, // s with dot below
    ILROCCI_EXTRA_25 = 0x038B, // h with dot below
    ILROCCI_EXTRA_26 = 0x038C, // u with breve
    ILROCCI_EXTRA_27 = 0x038D, // i with breve
    ILROCCI_EXTRA_28 = 0x038E, // c with dot below
    ILROCCI_EXTRA_29 = 0x038F, // r with grave and ring below
    ILROCCI_EXTRA_30 = 0x0390, // h with breve
    ILROCCI_EXTRA_31 = 0x0391, // t with dot below
    ILROCCI_EXTRA_32 = 0x0392, // r with dot above
    ILROCCI_EXTRA_33 = 0x0393, // m with dot above
    ILROCCI_EXTRA_34 = 0x03AE, // u with breve below
    ILROCCI_EXTRA_35 = 0x03AF, // a with macron and grave
    ILROCCI_EXTRA_36 = 0x03B0, // epsilon with macron
    ILROCCI_EXTRA_37 = 0x03B1, // italic o with macron
    ILROCCI_EXTRA_38 = 0x03B2, // e with macron
    ILROCCI_EXTRA_39 = 0x03B3, // italic e with macron
    ILROCCI_EXTRA_40 = 0x03B4, // i with macron
    ILROCCI_EXTRA_41 = 0x03B5, // italic i with macron
    ILROCCI_EXTRA_42 = 0x03B6, // i with caron
    ILROCCI_EXTRA_43 = 0x03B7, // italic i with caron
    ILROCCI_EXTRA_44 = 0x03B8, // o with macron         
    ILROCCI_EXTRA_45 = 0x03B9, // a with macron        
    ILROCCI_EXTRA_46 = 0x03BA, // italic a with macron 
    ILROCCI_EXTRA_47 = 0x03BB, // u with macron         
    ILROCCI_EXTRA_48 = 0x03BC, // italic u with macron    
    ILROCCI_EXTRA_49 = 0x03BD, // a with breve           
    ILROCCI_EXTRA_50 = 0x03BE, // italic a with breve
    ILROCCI_EXTRA_51 = 0x03BF, // upside down e         
    ILROCCI_EXTRA_52 = 0x03C0, // psili with perispomeni 
    ILROCCI_EXTRA_53 = 0x03C1, // dasia with perispomeni 
    ILROCCI_EXTRA_54 = 0x03C2, // psili with varia      
    ILROCCI_EXTRA_55 = 0x03C3, // psili with oxia
    ILROCCI_EXTRA_56 = 0x03C4, // dasia with varia
    ILROCCI_EXTRA_57 = 0x032D, // dash
    ILROCCI_EXTRA_58 = 0x033D, // equal
    ILROCCI_EXTRA_59 = 0x034F, // root
    ILROCCI_EXTRA_60 = 0x0350, // final sigma
    ILROCCI_EXTRA_61 = 0x0351, // pipe
    ILROCCI_EXTRA_62 = 0x0352, // dash with oxia
    ILROCCI_EXTRA_63 = 0x0353, // dash bottom half o
    ILROCCI_EXTRA_64 = 0x0354, // M under box
    ILROCCI_EXTRA_65 = 0x2219, // dot
    
};

#endif
