//
//  unicodeFontset.h
//  VerbiGreci
//
//  Created by Claudio Capobianco on 15/04/12.
//  Copyright (c) 2012 Librum. All rights reserved.
//

#ifndef unicodeFontset_h
#define unicodeFontset_h


// PSILI: spirito dolce  )
// DASIA: spirito aspro (
// VARIA: accento grave \
// OXIA:  accento acuto /
// PERISPOMENI:accento circonflesso ~
// YPOGERGRAMMENI: iota sottoscritto 
// VRACHY: accento breve
// MACRON: accento lungo

enum unicodeFontset {
    UNICODE_NONE = 0x0000,
    
    UNICODE_ALPHA = 0x03B1,
    UNICODE_ALPHA_OXIA2 = 0x03AC,
    UNICODE_ALPHA_PSILI = 0x1f00,
    UNICODE_ALPHA_DASIA = 0x1f01,
    UNICODE_ALPHA_PSILI_VARIA = 0x1f02,
    UNICODE_ALPHA_DASIA_VARIA = 0x1f03,
    UNICODE_ALPHA_PSILI_OXIA = 0x1f04,
    UNICODE_ALPHA_DASIA_OXIA = 0x1f05,
    UNICODE_ALPHA_PSILI_PERISPOMENI = 0x1f06,
    UNICODE_ALPHA_DASIA_PERISPOMENI = 0x1f07,
    UNICODE_ALPHA_VARIA = 0x1f70,
    UNICODE_ALPHA_OXIA = 0x1f71,
    UNICODE_ALPHA_PSILI_YPOGERGRAMMENI = 0x1f80,
    UNICODE_ALPHA_DASIA_YPOGERGRAMMENI = 0x1f81,
    UNICODE_ALPHA_PSILI_VARIA_YPOGERGRAMMENI = 0x1f82,
    UNICODE_ALPHA_DASIA_VARIA_YPOGERGRAMMENI = 0x1f83,
    UNICODE_ALPHA_PSILI_OXIA_YPOGERGRAMMENI = 0x1f84,
    UNICODE_ALPHA_DASIA_OXIA_YPOGERGRAMMENI = 0x1f85,
    UNICODE_ALPHA_PSILI_PERISPOMENI_YPOGERGRAMMENI = 0x1f86,
    UNICODE_ALPHA_DASIA_PERISPOMENI_YPOGERGRAMMENI = 0x1f87,
    UNICODE_ALPHA_VRACHY = 0x1FB0,
    UNICODE_ALPHA_VRACHY_OXIA = 0x1FB5, // extension
    UNICODE_ALPHA_MACRON = 0x1FB1,
    UNICODE_ALPHA_MACRON_OXIA = 0x1FF0, // extension
    UNICODE_ALPHA_MACRON_PSILI = 0x1FF1, // extension
    UNICODE_ALPHA_MACRON_DASIA = 0x1F7F, // extension
    UNICODE_ALPHA_VARIA_YPOGERGRAMMENI = 0x1FB2,
    UNICODE_ALPHA_YPOGERGRAMMENI = 0x1fb3,
    UNICODE_ALPHA_OXIA_YPOGERGRAMMENI = 0x1FB4,
    UNICODE_ALPHA_PERISPOMENI = 0x1FB6,
    UNICODE_ALPHA_PERISPOMENI_YPOGERGRAMMENI = 0x1FB7,
    
    UNICODE_EPSILON = 0x03b5,
    UNICODE_EPSILON_OXIA2 = 0x03AD,
    UNICODE_EPSILON_PSILI = 0x1f10,
    UNICODE_EPSILON_DASIA = 0x1f11,
    UNICODE_EPSILON_PSILI_VARIA = 0x1f12,
    UNICODE_EPSILON_DASIA_VARIA = 0x1f13,
    UNICODE_EPSILON_PSILI_OXIA = 0x1f14,
    UNICODE_EPSILON_DASIA_OXIA = 0x1f15,
    UNICODE_EPSILON_VARIA = 0x1f72,
    UNICODE_EPSILON_OXIA = 0x1f73,
    
    UNICODE_ETA = 0x03b7,
    UNICODE_ETA_OXIA2 = 0x03AE,
    UNICODE_ETA_PSILI = 0x1f20,
    UNICODE_ETA_DASIA = 0x1f21,
    UNICODE_ETA_PSILI_VARIA = 0x1f22,
    UNICODE_ETA_DASIA_VARIA = 0x1f23,
    UNICODE_ETA_PSILI_OXIA = 0x1f24,
    UNICODE_ETA_DASIA_OXIA = 0x1f25,
    UNICODE_ETA_PSILI_PERISPOMENI = 0x1f26,
    UNICODE_ETA_DASIA_PERISPOMENI = 0x1f27,
    UNICODE_ETA_VARIA = 0x1f74,
    UNICODE_ETA_OXIA = 0x1f75,
    UNICODE_ETA_PSILI_YPOGERGRAMMENI = 0x1f90,
    UNICODE_ETA_DASIA_YPOGERGRAMMENI = 0x1f91,
    UNICODE_ETA_PSILI_VARIA_YPOGERGRAMMENI = 0x1f92,
    UNICODE_ETA_DASIA_VARIA_YPOGERGRAMMENI = 0x1f93,
    UNICODE_ETA_PSILI_OXIA_YPOGERGRAMMENI = 0x1f94,
    UNICODE_ETA_DASIA_OXIA_YPOGERGRAMMENI = 0x1f95,
    UNICODE_ETA_PSILI_PERISPOMENI_YPOGERGRAMMENI = 0x1f96,
    UNICODE_ETA_DASIA_PERISPOMENI_YPOGERGRAMMENI = 0x1f97,
    UNICODE_ETA_VARIA_YPOGERGRAMMENI = 0x1FC2,
    UNICODE_ETA_YPOGERGRAMMENI = 0x1fC3,
    UNICODE_ETA_OXIA_YPOGERGRAMMENI = 0x1FC4,
    UNICODE_ETA_PERISPOMENI = 0x1FC6,
    UNICODE_ETA_PERISPOMENI_YPOGERGRAMMENI = 0x1FC7,
    
    UNICODE_IOTA = 0x03b9,
    UNICODE_IOTA_OXIA2 = 0x03AF,
    UNICODE_IOTA_PSILI = 0x1f30,
    UNICODE_IOTA_DASIA = 0x1f31,
    UNICODE_IOTA_PSILI_VARIA = 0x1f32,
    UNICODE_IOTA_DASIA_VARIA = 0x1f33,
    UNICODE_IOTA_PSILI_OXIA = 0x1f34,
    UNICODE_IOTA_DASIA_OXIA = 0x1f35,
    UNICODE_IOTA_PSILI_PERISPOMENI = 0x1f36,
    UNICODE_IOTA_DASIA_PERISPOMENI = 0x1f37,
    UNICODE_IOTA_VARIA = 0x1f76,
    UNICODE_IOTA_OXIA = 0x1f77,
    UNICODE_IOTA_VRACHY = 0x1FD0,
    UNICODE_IOTA_VRACHY_OXIA = 0x1FF5, // extension
    UNICODE_IOTA_MACRON = 0x1FD1,
    UNICODE_IOTA_MACRON_OXIA = 0x1FDC, // extension
    UNICODE_IOTA_VARIA_DIALYTIKA = 0x1FD2,
    UNICODE_IOTA_DIALYTIKA = 0x1fD3,
    UNICODE_IOTA_DIALYTIKA_VARIA = 0x1FD4, // extension
    UNICODE_IOTA_DIALYTIKA_OXIA = 0x1FD5, // extension
    UNICODE_IOTA_PERISPOMENI = 0x1FD6,
    UNICODE_IOTA_PERISPOMENI_DIALYTIKA = 0x1FD7,
    
    UNICODE_OMICRON = 0x03bf,
    UNICODE_OMICRON_PSILI = 0x1f40,
    UNICODE_OMICRON_DASIA = 0x1f41,
    UNICODE_OMICRON_PSILI_VARIA = 0x1f42,
    UNICODE_OMICRON_DASIA_VARIA = 0x1f43,
    UNICODE_OMICRON_PSILI_OXIA = 0x1f44,
    UNICODE_OMICRON_DASIA_OXIA = 0x1f45,
    UNICODE_OMICRON_VARIA = 0x1f78,
    UNICODE_OMICRON_OXIA = 0x1f79,
    
    UNICODE_UPSILON = 0x03c5,
    UNICODE_UPSILON_OXIA2 = 0x03B0,
    UNICODE_UPSILON_PSILI = 0x1f50,
    UNICODE_UPSILON_DASIA = 0x1f51,
    UNICODE_UPSILON_PSILI_VARIA = 0x1f52,
    UNICODE_UPSILON_DASIA_VARIA = 0x1f53,
    UNICODE_UPSILON_PSILI_OXIA = 0x1f54,
    UNICODE_UPSILON_DASIA_OXIA = 0x1f55,
    UNICODE_UPSILON_PSILI_PERISPOMENI = 0x1f56,
    UNICODE_UPSILON_DASIA_PERISPOMENI = 0x1f57,
    UNICODE_UPSILON_VARIA = 0x1f7A,
    UNICODE_UPSILON_OXIA = 0x1f7B,
    UNICODE_UPSILON_VRACHY = 0x1FE0,
    UNICODE_UPSILON_VRACHY_OXIA = 0x1F58, // extension
    UNICODE_UPSILON_MACRON = 0x1FE1,
    UNICODE_UPSILON_MACRON_OXIA = 0x1F5C, // extension
    UNICODE_UPSILON_VARIA_DIALYTIKA = 0x1FE2,
    UNICODE_UPSILON_OXIA_DIALYTIKA = 0x1F5A, // extension
    UNICODE_UPSILON_DIALYTIKA = 0x1fE3,
    UNICODE_UPSILON_PERISPOMENI = 0x1FE6,
    UNICODE_UPSILON_PERISPOMENI_DIALYTIKA = 0x1FE7,
    
    
    
    UNICODE_OMEGA = 0x03c9,
    UNICODE_OMEGA_PSILI = 0x1f60,
    UNICODE_OMEGA_DASIA = 0x1f61,
    UNICODE_OMEGA_PSILI_VARIA = 0x1f62,
    UNICODE_OMEGA_DASIA_VARIA = 0x1f63,
    UNICODE_OMEGA_PSILI_OXIA = 0x1f64,
    UNICODE_OMEGA_DASIA_OXIA = 0x1f65,
    UNICODE_OMEGA_PSILI_PERISPOMENI = 0x1f66,
    UNICODE_OMEGA_DASIA_PERISPOMENI = 0x1f67,
    UNICODE_OMEGA_VARIA = 0x1f7C,
    UNICODE_OMEGA_OXIA = 0x1f7D,
    UNICODE_OMEGA_PSILI_YPOGERGRAMMENI = 0x1fA0,
    UNICODE_OMEGA_DASIA_YPOGERGRAMMENI = 0x1fA1,
    UNICODE_OMEGA_PSILI_VARIA_YPOGERGRAMMENI = 0x1fA2,
    UNICODE_OMEGA_DASIA_VARIA_YPOGERGRAMMENI = 0x1fA3,
    UNICODE_OMEGA_PSILI_OXIA_YPOGERGRAMMENI = 0x1fA4,
    UNICODE_OMEGA_DASIA_OXIA_YPOGERGRAMMENI = 0x1fA5,
    UNICODE_OMEGA_PSILI_PERISPOMENI_YPOGERGRAMMENI = 0x1fA6,
    UNICODE_OMEGA_DASIA_PERISPOMENI_YPOGERGRAMMENI = 0x1fA7,
    UNICODE_OMEGA_VARIA_YPOGERGRAMMENI = 0x1FF2,
    UNICODE_OMEGA_YPOGERGRAMMENI = 0x1fF3,
    UNICODE_OMEGA_OXIA_YPOGERGRAMMENI = 0x1FF4,
    UNICODE_OMEGA_PERISPOMENI = 0x1FF6,
    UNICODE_OMEGA_PERISPOMENI_YPOGERGRAMMENI = 0x1FF7,
    
    UNICODE_RHO = 0x03C1,
    UNICODE_RHO_PSILI = 0x1FE4,
    UNICODE_RHO_DASIA = 0x1FE5,
    
    UNICODE_BETA = 0x03B2, 
    UNICODE_GAMMA = 0x03B3, 
    UNICODE_DELTA = 0x03B4, 
    UNICODE_ZETA = 0x03B6, 
    UNICODE_THETA = 0x03B8, 
    UNICODE_KAPPA = 0x03BA, 
    UNICODE_LAMBDA = 0x03BB, 
    UNICODE_MI = 0x03BC, 
    UNICODE_NI = 0x03BD, 
    UNICODE_XI = 0x03BE, 
    UNICODE_PI = 0x03C0, 
    UNICODE_SIGMA_FINAL = 0x03C2, 
    UNICODE_SIGMA = 0x03C3, 
    UNICODE_TAU = 0x03C4, 
    UNICODE_PHI = 0x03C6, 
    UNICODE_CHI = 0x03C7, 
    UNICODE_PSI = 0x03C8,
    
    UNICODE_CAPITAL_ALPHA = 0x0391,
    UNICODE_CAPITAL_ALPHA_PSILI = 0x1F08,
    UNICODE_CAPITAL_ALPHA_DASIA = 0x1F09,
    UNICODE_CAPITAL_ALPHA_PSILI_VARIA = 0x1F0A,
    UNICODE_CAPITAL_ALPHA_DASIA_VARIA = 0x1F0B,
    UNICODE_CAPITAL_ALPHA_PSILI_OXIA = 0x1F0C,
    UNICODE_CAPITAL_ALPHA_DASIA_OXIA = 0x1F0D,
    UNICODE_CAPITAL_ALPHA_PSILI_PERISPOMENI = 0x1F0E,
    UNICODE_CAPITAL_ALPHA_DASIA_PERISPOMENI = 0x1F0F,
    UNICODE_CAPITAL_ALPHA_VARIA = 0x1FBA,
    UNICODE_CAPITAL_ALPHA_OXIA = 0x1FBB,
    UNICODE_CAPITAL_ALPHA_VRACHY = 0x1FB8,
    UNICODE_CAPITAL_ALPHA_MACRON = 0x1FB9,
    UNICODE_CAPITAL_ALPHA_PERISPOMENI = 0x1FFF, // extension
    
    UNICODE_CAPITAL_BETA = 0x0392,
    UNICODE_CAPITAL_GAMMA = 0x0393,
    UNICODE_CAPITAL_DELTA = 0x0394,
    
    UNICODE_CAPITAL_EPSILON = 0x0395,
    UNICODE_CAPITAL_EPSILON_PSILI = 0x1f18,
    UNICODE_CAPITAL_EPSILON_DASIA = 0x1f19,
    UNICODE_CAPITAL_EPSILON_PSILI_VARIA = 0x1f1A,
    UNICODE_CAPITAL_EPSILON_DASIA_VARIA = 0x1f1B,
    UNICODE_CAPITAL_EPSILON_PSILI_OXIA = 0x1f1C,
    UNICODE_CAPITAL_EPSILON_DASIA_OXIA = 0x1f1D,
    UNICODE_CAPITAL_EPSILON_VARIA = 0x1fC8,
    UNICODE_CAPITAL_EPSILON_OXIA = 0x1fC9,
    
    UNICODE_CAPITAL_ZETA = 0x0396,
    
    UNICODE_CAPITAL_ETA = 0x0397,
    UNICODE_CAPITAL_ETA_PSILI = 0x1f28,
    UNICODE_CAPITAL_ETA_DASIA = 0x1f29,
    UNICODE_CAPITAL_ETA_PSILI_VARIA = 0x1f2A,
    UNICODE_CAPITAL_ETA_DASIA_VARIA = 0x1f2B,
    UNICODE_CAPITAL_ETA_PSILI_OXIA = 0x1f2C,
    UNICODE_CAPITAL_ETA_DASIA_OXIA = 0x1f2D,
    UNICODE_CAPITAL_ETA_PSILI_PERISPOMENI = 0x1f2E,
    UNICODE_CAPITAL_ETA_DASIA_PERISPOMENI = 0x1f2F,
    UNICODE_CAPITAL_ETA_VARIA = 0x1fCA,
    UNICODE_CAPITAL_ETA_OXIA = 0x1fCB,
    
    UNICODE_CAPITAL_THETA = 0x0398,
    
    UNICODE_CAPITAL_IOTA = 0x0399,
    UNICODE_CAPITAL_IOTA_PSILI = 0x1f38,
    UNICODE_CAPITAL_IOTA_DASIA = 0x1f39,
    UNICODE_CAPITAL_IOTA_PSILI_VARIA = 0x1f3A,
    UNICODE_CAPITAL_IOTA_DASIA_VARIA = 0x1f3B,
    UNICODE_CAPITAL_IOTA_PSILI_OXIA = 0x1f3C,
    UNICODE_CAPITAL_IOTA_DASIA_OXIA = 0x1f3D,
    UNICODE_CAPITAL_IOTA_PSILI_PERISPOMENI = 0x1f3E,
    UNICODE_CAPITAL_IOTA_DASIA_PERISPOMENI = 0x1f3F,
    UNICODE_CAPITAL_IOTA_VARIA = 0x1fDA,
    UNICODE_CAPITAL_IOTA_OXIA = 0x1fDB,
    UNICODE_CAPITAL_IOTA_VRACHY = 0x1FD8,
    UNICODE_CAPITAL_IOTA_MACRON = 0x1FD9,
    
    UNICODE_CAPITAL_KAPPA = 0x039A,
    UNICODE_CAPITAL_LAMBDA = 0x039B,
    UNICODE_CAPITAL_MI = 0x039C,
    UNICODE_CAPITAL_NI = 0x039D,
    UNICODE_CAPITAL_XI = 0x039E,
    
    UNICODE_CAPITAL_OMICRON = 0x039F,
    UNICODE_CAPITAL_OMICRON_PSILI = 0x1f48,
    UNICODE_CAPITAL_OMICRON_DASIA = 0x1f49,
    UNICODE_CAPITAL_OMICRON_PSILI_VARIA = 0x1f4A,
    UNICODE_CAPITAL_OMICRON_DASIA_VARIA = 0x1f4B,
    UNICODE_CAPITAL_OMICRON_PSILI_OXIA = 0x1f4C,
    UNICODE_CAPITAL_OMICRON_DASIA_OXIA = 0x1f4D,
    UNICODE_CAPITAL_OMICRON_VARIA = 0x1fF8,
    UNICODE_CAPITAL_OMICRON_OXIA = 0x1fF9,
    
    UNICODE_CAPITAL_PI = 0x03A0,
    
    UNICODE_CAPITAL_RHO = 0x03A1,
    UNICODE_CAPITAL_RHO_DASIA = 0x1FEC,
    
    UNICODE_CAPITAL_SIGMA = 0x03A3,
    UNICODE_CAPITAL_TAU = 0x03A4,
    
    UNICODE_CAPITAL_UPSILON = 0x03A5,
    UNICODE_CAPITAL_UPSILON_DASIA = 0x1f59,
    UNICODE_CAPITAL_UPSILON_DASIA_VARIA = 0x1f5B,
    UNICODE_CAPITAL_UPSILON_DASIA_OXIA = 0x1f5D,
    UNICODE_CAPITAL_UPSILON_DASIA_PERISPOMENI = 0x1f5F,
    UNICODE_CAPITAL_UPSILON_VARIA = 0x1fEA,
    UNICODE_CAPITAL_UPSILON_OXIA = 0x1fEB,
    UNICODE_CAPITAL_UPSILON_VRACHY = 0x1FE8,
    UNICODE_CAPITAL_UPSILON_MACRON = 0x1FE9,
    
    UNICODE_CAPITAL_PHI = 0x03A6,
    UNICODE_CAPITAL_CHI = 0x03A7,
    UNICODE_CAPITAL_PSI = 0x03A8,
    
    UNICODE_CAPITAL_OMEGA = 0x03A9,
    UNICODE_CAPITAL_OMEGA_PSILI = 0x1f68,
    UNICODE_CAPITAL_OMEGA_DASIA = 0x1f69,
    UNICODE_CAPITAL_OMEGA_PSILI_VARIA = 0x1f6A,
    UNICODE_CAPITAL_OMEGA_DASIA_VARIA = 0x1f6B,
    UNICODE_CAPITAL_OMEGA_PSILI_OXIA = 0x1f6C,
    UNICODE_CAPITAL_OMEGA_DASIA_OXIA = 0x1f6D,
    UNICODE_CAPITAL_OMEGA_PSILI_PERISPOMENI = 0x1f6E,
    UNICODE_CAPITAL_OMEGA_DASIA_PERISPOMENI = 0x1f6F,
    UNICODE_CAPITAL_OMEGA_VARIA = 0x1FFA,
    UNICODE_CAPITAL_OMEGA_OXIA = 0x1FFB,
    
    UNICODE_DIGAMMA = 0x03DC,
    
    // Signs
    UNICODE_SIGN_PSILI = 0x1FBF,
    UNICODE_SIGN_DASIA = 0x1FFE,
    UNICODE_SIGN_VARIA = 0x1FEF,
    UNICODE_SIGN_OXIA = 0x1FFD,
    UNICODE_SIGN_PERISPOMENI = 0x1FC0,
    UNICODE_SIGN_YPOGERGRAMMENI = 0x1FBE,
    
    // Punctuation
    UNICODE_PUNCT_SPACE = ' ',
    UNICODE_PUNCT_PARENTHESES_OPEN = '(',
    UNICODE_PUNCT_PARENTHESES_CLOSE = ')',
    UNICODE_PUNCT_DOT = '.',
    UNICODE_PUNCT_DASH = '-',
    UNICODE_PUNCT_COMMA = ',',
    
    UNICODE_PUNCT_ELLIPSIS = 0X2026, 
    UNICODE_PUNCT_COLON = ':',
    UNICODE_PUNCT_SEMICOLON = ';',
    UNICODE_PUNCT_QUESTION_MARK = '?',
    UNICODE_PUNCT_EXCLAMATION_MARK = '!',
    UNICODE_PUNCT_SLASH = '/',
    UNICODE_PUNCT_PERMIL = 0x2030,
    UNICODE_PUNCT_LONG_DASH = 0x2012,
    UNICODE_PUNCT_XXL_DASH = 0x2014,
    UNICODE_PUNCT_DQUOTE_OPEN = 0x201C,
    
    UNICODE_ACCENT_ACUTE = 0X00B4,
    UNICODE_ACCENT_ACUTE_LOW = 0x0317,
    
    UNICODE_LATIN_S_CARON = 0x0161,
    
    // all the following are extension, placed in the unicode private area
    UNICODE_EXTRA_01 = 0xE000, 
    UNICODE_EXTRA_02 = 0xE001,
    UNICODE_EXTRA_03 = 0xE002,
    UNICODE_EXTRA_04 = 0xE003,
    UNICODE_EXTRA_05 = 0xE004,
    UNICODE_EXTRA_06 = 0xE005,
    UNICODE_EXTRA_07 = 0xE006,
    UNICODE_EXTRA_08 = 0xE007,
    UNICODE_EXTRA_09 = 0xE008,
    UNICODE_EXTRA_10 = 0xE009,
    UNICODE_EXTRA_11 = 0xE00A,
    UNICODE_EXTRA_12 = 0xE00B,
    UNICODE_EXTRA_13 = 0xE00C,
    UNICODE_EXTRA_14 = 0xE00D,
    UNICODE_EXTRA_15 = 0xE00E,
    UNICODE_EXTRA_16 = 0xE00F,
    UNICODE_EXTRA_17 = 0xE010,
    UNICODE_EXTRA_18 = 0xE011,
    UNICODE_EXTRA_19 = 0xE012,
    UNICODE_EXTRA_20 = 0xE013,
    UNICODE_EXTRA_21 = 0xE014,
    UNICODE_EXTRA_22 = 0xE015,
    UNICODE_EXTRA_23 = 0xE016,
    UNICODE_EXTRA_24 = 0xE017,
    UNICODE_EXTRA_25 = 0xE018,
    UNICODE_EXTRA_26 = 0xE019,
    UNICODE_EXTRA_27 = 0xE01A,
    UNICODE_EXTRA_28 = 0xE01B,
    UNICODE_EXTRA_29 = 0xE01C,
    UNICODE_EXTRA_30 = 0xE01D,
    UNICODE_EXTRA_31 = 0xE01E,
    UNICODE_EXTRA_32 = 0xE01F,
    UNICODE_EXTRA_33 = 0xE020,
    UNICODE_EXTRA_34 = 0xE021,
    UNICODE_EXTRA_35 = 0xE022,
    UNICODE_EXTRA_36 = 0xE023,
    UNICODE_EXTRA_37 = 0xE024,
    UNICODE_EXTRA_38 = 0xE025,
    UNICODE_EXTRA_39 = 0xE026,
    UNICODE_EXTRA_40 = 0xE027,
    UNICODE_EXTRA_41 = 0xE028,
    UNICODE_EXTRA_42 = 0xE029,
    UNICODE_EXTRA_43 = 0xE02A,
    UNICODE_EXTRA_44 = 0xE02B,
    UNICODE_EXTRA_45 = 0xE02C,
    UNICODE_EXTRA_46 = 0xE02D,
    UNICODE_EXTRA_47 = 0xE02E,
    UNICODE_EXTRA_48 = 0xE02F,
    UNICODE_EXTRA_49 = 0xE030,
    UNICODE_EXTRA_50 = 0xE031,
    UNICODE_EXTRA_51 = 0xE032,
    UNICODE_EXTRA_52 = 0xE033,
    UNICODE_EXTRA_53 = 0xE034,
    UNICODE_EXTRA_54 = 0xE035,
    UNICODE_EXTRA_55 = 0xE036,
    UNICODE_EXTRA_56 = 0xE037,
    UNICODE_EXTRA_57 = 0xE038,
    UNICODE_EXTRA_58 = 0xE039,
    UNICODE_EXTRA_59 = 0xE03A,
    UNICODE_EXTRA_60 = 0xE03B,
    UNICODE_EXTRA_61 = 0xE03C,
    UNICODE_EXTRA_62 = 0xE03D,
    UNICODE_EXTRA_63 = 0xE03E,
    UNICODE_EXTRA_64 = 0xE03F,
    UNICODE_EXTRA_65 = 0xE040,

};



#endif
